---
title: Ambient Light Events
slug: Web/API/Ambient_Light_Events
tags:
  - Ambient Light
---
<div>{{DefaultAPISidebar("Ambient Light Events")}}{{SeeCompatTable}}</div>

<p>The ambient light events are a handy way to make a web page or an application aware of any change in the light intensity. It allows them to react to such a change, for example by changing the color contrast of the User Interface (UI) or by changing the exposure necessary to take a picture.</p>

<div class="notecard note">
<p><strong>Note:</strong> This API is <em>not available</em> in <a href="/en-US/docs/Web/API/Web_Workers_API">Web Workers</a> (it is not exposed in the <a href="/en-US/docs/Web/API/Web_Workers_API#Worker_global_contexts_and_functions">worker global context</a>).</p>
</div>

<h2 id="Light_Events">Light Events</h2>

<p>When the light sensor of a device detects a change in the light level, it notifies the browser of that change. When the browser gets such a notification, it fires a {{domxref("DeviceLightEvent")}} event that provides information about the exact light intensity (in lux units).</p>

<p>This event can be captured at the <code>window</code> object level by using the {{domxref("EventTarget.addEventListener","addEventListener")}} method (using the {{event("devicelight")}} event name) or by attaching an event handler to the {{domxref("window.ondevicelight")}} property.</p>

<p>Once captured, the event object gives access to the light intensity expressed in {{interwiki("wikipedia", "lux")}} through the {{domxref("DeviceLightEvent.value")}} property.</p>

<h2 id="Example">Example</h2>

<pre class="brush: js notranslate">if ('ondevicelight' in window) {
  window.addEventListener('devicelight', function(event) {
    var body = document.querySelector('body');
    if (event.value &lt; 50) {
      body.classList.add('darklight');
      body.classList.remove('brightlight');
    } else {
      body.classList.add('brightlight');
      body.classList.remove('darklight');
    }
  });
} else {
  console.log('devicelight event not supported');
}
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName("AmbientLight", "", "Ambient Light Events")}}</td>
   <td>{{Spec2("AmbientLight")}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.DeviceLightEvent")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("DeviceLightEvent")}}</li>
 <li>{{event("devicelight")}}</li>
</ul>
